using System.Numerics;

using Microsoft.UI;
using Microsoft.UI.Composition;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Hosting;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        this.InitializeComponent();

        Visual gridVisual = ElementCompositionPreview.GetElementVisual(this.grid);

        Compositor compositor = gridVisual.Compositor;

        CompositionColorBrush compositionColorBrush = compositor.CreateColorBrush(Colors.Blue);

        DropShadow dropShadow = compositor.CreateDropShadow();

        dropShadow.BlurRadius = 15.0f;
        dropShadow.Offset     = new Vector3(10, 10, 0);
        dropShadow.Color      = Colors.Black;

        SpriteVisual spriteVisual = compositor.CreateSpriteVisual();

        spriteVisual.Size   = new Vector2(200, 200);
        spriteVisual.Offset = new Vector3(100, 100, 0);
        spriteVisual.Brush  = compositionColorBrush;
        spriteVisual.Shadow = dropShadow;

        ContainerVisual containerVisual = compositor.CreateContainerVisual();

        containerVisual.Children.InsertAtTop(spriteVisual);

        ElementCompositionPreview.SetElementChildVisual(this.grid, containerVisual);
    }

    #endregion
}